/**************************************************************************/
/*  doc_data_class_path.gen.h                                             */
/**************************************************************************/
/*                         This file is part of:                          */
/*                             GODOT ENGINE                               */
/*                        https://godotengine.org                         */
/**************************************************************************/
/* Copyright (c) 2014-present Godot Engine contributors (see AUTHORS.md). */
/* Copyright (c) 2007-2014 Juan Linietsky, Ariel Manzur.                  */
/*                                                                        */
/* Permission is hereby granted, free of charge, to any person obtaining  */
/* a copy of this software and associated documentation files (the        */
/* "Software"), to deal in the Software without restriction, including    */
/* without limitation the rights to use, copy, modify, merge, publish,    */
/* distribute, sublicense, and/or sell copies of the Software, and to     */
/* permit persons to whom the Software is furnished to do so, subject to  */
/* the following conditions:                                              */
/*                                                                        */
/* The above copyright notice and this permission notice shall be         */
/* included in all copies or substantial portions of the Software.        */
/*                                                                        */
/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,        */
/* EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF     */
/* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. */
/* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY   */
/* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,   */
/* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE      */
/* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                 */
/**************************************************************************/

/* THIS FILE IS GENERATED. EDITS WILL BE LOST. */

#ifndef DOC_DATA_CLASS_PATH_GEN_H
#define DOC_DATA_CLASS_PATH_GEN_H

static const int _doc_data_class_path_count = 114;

struct _DocDataClassPath {
	const char *name;
	const char *path;
};

static const _DocDataClassPath _doc_data_class_paths[115] = {
	{"@GDScript", "modules/gdscript/doc_classes"},
	{"AudioStreamInteractive", "modules/interactive_music/doc_classes"},
	{"AudioStreamMP3", "modules/minimp3/doc_classes"},
	{"AudioStreamOggVorbis", "modules/vorbis/doc_classes"},
	{"AudioStreamPlaybackInteractive", "modules/interactive_music/doc_classes"},
	{"AudioStreamPlaybackOggVorbis", "modules/vorbis/doc_classes"},
	{"AudioStreamPlaybackPlaylist", "modules/interactive_music/doc_classes"},
	{"AudioStreamPlaybackSynchronized", "modules/interactive_music/doc_classes"},
	{"AudioStreamPlaylist", "modules/interactive_music/doc_classes"},
	{"AudioStreamSynchronized", "modules/interactive_music/doc_classes"},
	{"CSGBox3D", "modules/csg/doc_classes"},
	{"CSGCombiner3D", "modules/csg/doc_classes"},
	{"CSGCylinder3D", "modules/csg/doc_classes"},
	{"CSGMesh3D", "modules/csg/doc_classes"},
	{"CSGPolygon3D", "modules/csg/doc_classes"},
	{"CSGPrimitive3D", "modules/csg/doc_classes"},
	{"CSGShape3D", "modules/csg/doc_classes"},
	{"CSGSphere3D", "modules/csg/doc_classes"},
	{"CSGTorus3D", "modules/csg/doc_classes"},
	{"ENetConnection", "modules/enet/doc_classes"},
	{"ENetMultiplayerPeer", "modules/enet/doc_classes"},
	{"ENetPacketPeer", "modules/enet/doc_classes"},
	{"EditorExportPlatformAndroid", "platform/android/doc_classes"},
	{"EditorExportPlatformIOS", "platform/ios/doc_classes"},
	{"EditorExportPlatformLinuxBSD", "platform/linuxbsd/doc_classes"},
	{"EditorExportPlatformMacOS", "platform/macos/doc_classes"},
	{"EditorExportPlatformWeb", "platform/web/doc_classes"},
	{"EditorExportPlatformWindows", "platform/windows/doc_classes"},
	{"EditorSceneFormatImporterBlend", "modules/gltf/doc_classes"},
	{"EditorSceneFormatImporterFBX2GLTF", "modules/fbx/doc_classes"},
	{"EditorSceneFormatImporterGLTF", "modules/gltf/doc_classes"},
	{"EditorSceneFormatImporterUFBX", "modules/fbx/doc_classes"},
	{"FBXDocument", "modules/fbx/doc_classes"},
	{"FBXState", "modules/fbx/doc_classes"},
	{"FastNoiseLite", "modules/noise/doc_classes"},
	{"GDScript", "modules/gdscript/doc_classes"},
	{"GDScriptSyntaxHighlighter", "modules/gdscript/doc_classes"},
	{"GLTFAccessor", "modules/gltf/doc_classes"},
	{"GLTFAnimation", "modules/gltf/doc_classes"},
	{"GLTFBufferView", "modules/gltf/doc_classes"},
	{"GLTFCamera", "modules/gltf/doc_classes"},
	{"GLTFDocument", "modules/gltf/doc_classes"},
	{"GLTFDocumentExtension", "modules/gltf/doc_classes"},
	{"GLTFDocumentExtensionConvertImporterMesh", "modules/gltf/doc_classes"},
	{"GLTFLight", "modules/gltf/doc_classes"},
	{"GLTFMesh", "modules/gltf/doc_classes"},
	{"GLTFNode", "modules/gltf/doc_classes"},
	{"GLTFObjectModelProperty", "modules/gltf/doc_classes"},
	{"GLTFPhysicsBody", "modules/gltf/doc_classes"},
	{"GLTFPhysicsShape", "modules/gltf/doc_classes"},
	{"GLTFSkeleton", "modules/gltf/doc_classes"},
	{"GLTFSkin", "modules/gltf/doc_classes"},
	{"GLTFSpecGloss", "modules/gltf/doc_classes"},
	{"GLTFState", "modules/gltf/doc_classes"},
	{"GLTFTexture", "modules/gltf/doc_classes"},
	{"GLTFTextureSampler", "modules/gltf/doc_classes"},
	{"GridMap", "modules/gridmap/doc_classes"},
	{"GridMapEditorPlugin", "modules/gridmap/doc_classes"},
	{"MobileVRInterface", "modules/mobile_vr/doc_classes"},
	{"MultiplayerSpawner", "modules/multiplayer/doc_classes"},
	{"MultiplayerSynchronizer", "modules/multiplayer/doc_classes"},
	{"Noise", "modules/noise/doc_classes"},
	{"NoiseTexture2D", "modules/noise/doc_classes"},
	{"NoiseTexture3D", "modules/noise/doc_classes"},
	{"OfflineMultiplayerPeer", "modules/multiplayer/doc_classes"},
	{"OggPacketSequence", "modules/ogg/doc_classes"},
	{"OggPacketSequencePlayback", "modules/ogg/doc_classes"},
	{"OpenXRAPIExtension", "modules/openxr/doc_classes"},
	{"OpenXRAction", "modules/openxr/doc_classes"},
	{"OpenXRActionBindingModifier", "modules/openxr/doc_classes"},
	{"OpenXRActionMap", "modules/openxr/doc_classes"},
	{"OpenXRActionSet", "modules/openxr/doc_classes"},
	{"OpenXRAnalogThresholdModifier", "modules/openxr/doc_classes"},
	{"OpenXRBindingModifier", "modules/openxr/doc_classes"},
	{"OpenXRBindingModifierEditor", "modules/openxr/doc_classes"},
	{"OpenXRCompositionLayer", "modules/openxr/doc_classes"},
	{"OpenXRCompositionLayerCylinder", "modules/openxr/doc_classes"},
	{"OpenXRCompositionLayerEquirect", "modules/openxr/doc_classes"},
	{"OpenXRCompositionLayerQuad", "modules/openxr/doc_classes"},
	{"OpenXRDpadBindingModifier", "modules/openxr/doc_classes"},
	{"OpenXRExtensionWrapperExtension", "modules/openxr/doc_classes"},
	{"OpenXRHand", "modules/openxr/doc_classes"},
	{"OpenXRHapticBase", "modules/openxr/doc_classes"},
	{"OpenXRHapticVibration", "modules/openxr/doc_classes"},
	{"OpenXRIPBinding", "modules/openxr/doc_classes"},
	{"OpenXRIPBindingModifier", "modules/openxr/doc_classes"},
	{"OpenXRInteractionProfile", "modules/openxr/doc_classes"},
	{"OpenXRInteractionProfileEditor", "modules/openxr/doc_classes"},
	{"OpenXRInteractionProfileEditorBase", "modules/openxr/doc_classes"},
	{"OpenXRInteractionProfileMetadata", "modules/openxr/doc_classes"},
	{"OpenXRInterface", "modules/openxr/doc_classes"},
	{"OpenXRVisibilityMask", "modules/openxr/doc_classes"},
	{"RegEx", "modules/regex/doc_classes"},
	{"RegExMatch", "modules/regex/doc_classes"},
	{"ResourceImporterMP3", "modules/minimp3/doc_classes"},
	{"ResourceImporterOggVorbis", "modules/vorbis/doc_classes"},
	{"SceneMultiplayer", "modules/multiplayer/doc_classes"},
	{"SceneReplicationConfig", "modules/multiplayer/doc_classes"},
	{"TextServerAdvanced", "modules/text_server_adv/doc_classes"},
	{"UPNP", "modules/upnp/doc_classes"},
	{"UPNPDevice", "modules/upnp/doc_classes"},
	{"VideoStreamTheora", "modules/theora/doc_classes"},
	{"WebRTCDataChannel", "modules/webrtc/doc_classes"},
	{"WebRTCDataChannelExtension", "modules/webrtc/doc_classes"},
	{"WebRTCMultiplayerPeer", "modules/webrtc/doc_classes"},
	{"WebRTCPeerConnection", "modules/webrtc/doc_classes"},
	{"WebRTCPeerConnectionExtension", "modules/webrtc/doc_classes"},
	{"WebSocketClient", "modules/websocket/doc_classes"},
	{"WebSocketMultiplayerPeer", "modules/websocket/doc_classes"},
	{"WebSocketPeer", "modules/websocket/doc_classes"},
	{"WebSocketServer", "modules/websocket/doc_classes"},
	{"WebXRInterface", "modules/webxr/doc_classes"},
	{"ZIPPacker", "modules/zip/doc_classes"},
	{"ZIPReader", "modules/zip/doc_classes"},
	{nullptr, nullptr},
};

#endif // DOC_DATA_CLASS_PATH_GEN_H
