/**************************************************************************/
/*  editor_version_button.h                                               */
/**************************************************************************/
/*                         This file is part of:                          */
/*                             GODOT ENGINE                               */
/*                        https://godotengine.org                         */
/**************************************************************************/
/* Copyright (c) 2014-present Godot Engine contributors (see AUTHORS.md). */
/* Copyright (c) 2007-2014 Juan Linietsky, Ariel Manzur.                  */
/*                                                                        */
/* Permission is hereby granted, free of charge, to any person obtaining  */
/* a copy of this software and associated documentation files (the        */
/* "Software"), to deal in the Software without restriction, including    */
/* without limitation the rights to use, copy, modify, merge, publish,    */
/* distribute, sublicense, and/or sell copies of the Software, and to     */
/* permit persons to whom the Software is furnished to do so, subject to  */
/* the following conditions:                                              */
/*                                                                        */
/* The above copyright notice and this permission notice shall be         */
/* included in all copies or substantial portions of the Software.        */
/*                                                                        */
/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,        */
/* EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF     */
/* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. */
/* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY   */
/* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,   */
/* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE      */
/* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                 */
/**************************************************************************/

#ifndef EDITOR_VERSION_BUTTON_H
#define EDITOR_VERSION_BUTTON_H

#include "scene/gui/link_button.h"

class EditorVersionButton : public LinkButton {
	GDCLASS(EditorVersionButton, LinkButton);

public:
	enum VersionFormat {
		// 4.3.2.stable
		FORMAT_BASIC,
		// v4.3.2.stable.mono [HASH]
		FORMAT_WITH_BUILD,
		// Godot Engine v4.3.2.stable.mono.official [HASH]
		FORMAT_WITH_NAME_AND_BUILD,
	};

private:
	VersionFormat format = FORMAT_WITH_NAME_AND_BUILD;

protected:
	void _notification(int p_what);

	virtual void pressed() override;

public:
	EditorVersionButton(VersionFormat p_format);
};

#endif // EDITOR_VERSION_BUTTON_H
